###############################
## ABDpred Server
## Version 1.0
###############################

from keras.wrappers.scikit_learn import KerasClassifier
from sklearn.model_selection import cross_val_score
from keras.layers import Dense, Dropout, Flatten
from keras.models import Sequential
from keras.layers import Dense
import pandas as pd
from keras import regularizers
from keras.layers import Dense, Dropout, Flatten
from sklearn.model_selection import StratifiedKFold

import warnings  
warnings.filterwarnings('ignore')

df = pd.read_csv(r"train_1_1_work_1.csv", sep=',')
df.describe()
df.head()
X_train= df.drop('Label',axis=1)
y_train= df.Label



def build_classifier():
    classifier = Sequential()
    classifier.add(Dense(units = 10, kernel_initializer = 'uniform', activation = 'relu', input_dim = 17))
    classifier.add(Dense(units = 10, kernel_initializer = 'uniform', activation = 'relu'))
    classifier.add(Dense(units = 1, kernel_initializer = 'uniform', activation = 'sigmoid'))
    classifier.compile(optimizer = 'adam', loss = 'binary_crossentropy', metrics = ['accuracy'])
    return classifier
classifier = KerasClassifier(build_fn = build_classifier, batch_size = 5, epochs = 100,verbose=0)
accuracies = cross_val_score(estimator = classifier, X = X_train, y = y_train, cv = StratifiedKFold(5))
print (accuracies)
mean = accuracies.mean()
variance = accuracies.std()
print('Mean accuracy score of 5 different models using Stratified KFold cross validation: {}'.format(mean))
print('Standard Deviation of accuracy score of 5 different models using Stratified KFold cross validation: {}'.format(variance))

new_model = tf.keras.models.load_model('model2')

blindset= pd.read_csv(r'blind_1_1_work_1.csv',sep=',')
Z= blindset.drop('Label',axis=1)
z= blindset['Label']
pred_blind_dnn= new_model.predict(Z)
pred_blind_dnn = (pred_blind_dnn > 0.55)


print("DNN Blind Validation classification report: " , classification_report(z, pred_blind_dnn))

tn, fp, fn, tp=confusion_matrix(z, pred_blind_dnn).ravel()
specificity=(tn/1.0)/(fp+tn)
sensitivity = (tp/1.0)/(tp+fn)
f1=(2*tp/1.0)/(2*tp+fp+fn)
precision=(tp/1.0)/(tp+fp)
fpr, tpr, thresholds = metrics.roc_curve(z, pred_blind_dnn)
AUC=metrics.auc(fpr, tpr)


print ("Sensitivity ","Specificity ","Accuracy " ,"precision " , "f1-score " ,"AUC value ")
print(sensitivity,specificity,result,precision,f1, AUC)
#print ("at thresholds: ", thresholds)


ax = plt.gca()
rfc_disp1 = plot_roc_curve(loaded_model, Z, z, ax=ax, alpha=0.8)
plt.show()



