###############################
## ABDpred Server
## Version 1.0
###############################

from keras.wrappers.scikit_learn import KerasClassifier
from sklearn.model_selection import cross_val_score
from keras.layers import Dense, Dropout, Flatten
from keras.models import Sequential
from keras.layers import Dense
import pandas as pd
from keras import regularizers
from keras.layers import Dense, Dropout, Flatten
from sklearn.model_selection import StratifiedKFold
from tensorflow.keras.losses import sparse_categorical_crossentropy
import warnings  
warnings.filterwarnings('ignore')

from sklearn.model_selection import cross_val_score
from keras import regularizers
from tensorflow import keras
from keras.layers import Dense, Dropout, Flatten
from keras.wrappers.scikit_learn import KerasClassifier
import numpy as np 
import pandas as pd 
import os
from tensorflow.keras.losses import sparse_categorical_crossentropy
from sklearn.preprocessing import StandardScaler
import keras
import tensorflow as tf
import matplotlib.pyplot as plt
import seaborn as sns
from keras.utils import plot_model  
sns.set()
import matplotlib.pyplot as plt
#import dill as pickle
from keras.models import Sequential
from keras.layers import Dense
from sklearn.model_selection import train_test_split
from sklearn.metrics import confusion_matrix,roc_auc_score, classification_report
from sklearn import metrics
from sklearn.metrics import roc_curve, auc, plot_roc_curve
import pickle
from sklearn.metrics import accuracy_score




#dataset load using pandas
dataset = pd.read_csv(r'train_1_1_work_1.csv',sep=',')
#print (dataset)
#if required to print dataset head 
#dataset_top = dataset.head() 
#print (dataset_top)
#columns available for the dataset
#for col in dataset.columns: 
    #print(col) 
print (dataset.columns)

#X here represents either positive (1) or negative (0) lablled
X= dataset.drop('Label',axis=1)

print ("Shape of the featured data for X", X.shape)
#y here presents here all features or column except laballed named as 'Label'
y= dataset['Label']
print ("Shape of the lablled data for y",y.shape)
X_train= dataset.drop('Label',axis=1)
y_train= dataset.Label
#sc = StandardScaler()
#X_train = sc.fit_transform(X_train)


def build_classifier():
    classifier = Sequential()
    classifier.add(Dense(units = 10, kernel_initializer = 'uniform', activation = 'relu', input_dim = 17))
    classifier.add(Dense(units = 10, kernel_initializer = 'uniform', activation = 'relu'))
    classifier.add(Dense(units = 1, kernel_initializer = 'uniform', activation = 'sigmoid'))
    classifier.compile(optimizer = 'adam', loss = 'binary_crossentropy', metrics = ['accuracy'])
    return classifier
classifier = KerasClassifier(build_fn = build_classifier, batch_size = 5, epochs = 100,verbose=0)
accuracies = cross_val_score(estimator = classifier, X = X_train, y = y_train, cv = StratifiedKFold(5))
print (accuracies)
mean = accuracies.mean()
variance = accuracies.std()
print('Mean accuracy score of 5 different models using Stratified KFold cross validation: {}'.format(mean))
print('Standard Deviation of accuracy score of 5 different models using Stratified KFold cross validation: {}'.format(variance))


print(".............................")
print("Five fold cross validation using StratifiedKFold.....")

accuracy=[]
specifity_score=[]
sensitivity_score=[]
f1_score=[]
precision_score=[]
AUC_score=[]


skf=StratifiedKFold(n_splits=5, random_state=None)
skf.get_n_splits(X,y)

print ("Fold, Sensitivity","Specificity","Accuracy","precision", "f1-score","AUC value")
i=0
for train_index, test_index in skf.split(X,y):
    #print("Train:", train_index, "Validation", test_index)
    X1_train, X1_test=X.iloc[train_index], X.iloc[test_index]
    y1_train, y1_test=y.iloc[train_index], y.iloc[test_index]
    classifier.fit(X1_train, y1_train)
    prediction=classifier.predict(X1_test)
    
    
    
    
    
    
    fpr, tpr, thresholds = metrics.roc_curve(y1_test, prediction)
    AUC=metrics.auc(fpr, tpr)
    AUC_score.append(AUC)
    score=accuracy_score(prediction, y1_test)
    accuracy.append(score)
    tn, fp, fn, tp=confusion_matrix(y1_test, prediction).ravel()
    specificity=(tn/1.0)/(fp+tn)
    sensitivity = (tp)/(tp+fn)
    f1=(2*tp)/(2*tp+fp+fn)
    precision=(tp)/(tp+fp)
    
    print(i,sensitivity,specificity,score,precision,f1, AUC)
    sensitivity_score.append(sensitivity)
    specifity_score.append(specificity)
    f1_score.append(f1)
    precision_score.append(precision)
    
    #print ("fold",i,tn)
    #print ("fold",i,fp)
    #print ("fold",i,fn)
    #print ("fold",i,tp)
    
    #filename = ('saved_model/my_model')
    #print (filename)
    #pickle.dump(classifier, open(filename, 'wb'))
    #classifier.save('my_model'+str(i))
    m = build_classifier()
    tf.saved_model.save(m, 'model'+str(i))
    #tf.keras.models.save_model(my_model, filename)
    
    #filename = ('model'+str(i))
    #loaded_model = pickle.load(open(filename, 'rb'))
    #resulting = loaded_model.score(X1_test, y1_test)
    #print("Accuracy made by model", filename, resulting)
    
    
    
    i=i+1
    
#print ("Accuracy array:", accuracy)
print(".............................")
print ("Avg_Sensitivity","Avg_Specificity","Avg_Accuracy","Avg_precision", "Avg_f1-score","Avg_AUC")

print(np.mean(sensitivity_score), np.mean(specifity_score), np.mean(accuracy), np.mean(precision_score), np.mean(f1_score), np.mean(AUC_score))

#print ("After five fold cross validation sensitivity_score: ", np.mean(sensitivity_score))
#print ("After five fold cross validation specifity_score: ", np.mean(specifity_score))
#print("After five fold cross validation average Accuracy score:", np.mean(accuracy))
#print ("After five fold cross validation precision_score: ", np.mean(precision_score))
#print ("After five fold cross validation f1_score: ", np.mean(f1_score))


print("................................")
print("Loaded saved model")
new_model = tf.keras.models.load_model('model1')

new_model.summary()

blindset= pd.read_csv(r'blind_1_1_work_1.csv',sep=',')
Z= blindset.drop('Label',axis=1)
z= blindset['Label']
pred_blind_dnn= new_model.predict(Z)
print (pred_blind_dnn)
pred_blind_dnn = (pred_blind_dnn > 0.5)
#print (pred_blind_dnn)
print(classification_report(z,pred_blind_dnn))
tn, fp, fn, tp=confusion_matrix(z,pred_blind_dnn).ravel()
#print (tn)
#print (fp)
#print (fn)
#print (tp)

sensitivity = (tp)/(tp+fn)
specificity=(tn/1.0)/(fp+tn)
accuracy=(tp+tn)/(tp+fp+fn+tn)
precision=(tp)/(tp+fp)
f1_score=(2*tp)/(2*tp+fp+fn)
fpr, tpr, thresholds = metrics.roc_curve(z, pred_blind_dnn)
roc_auc= auc(fpr, tpr)

print ("Sensitivity","Specificity","Accuracy","precision", "f1-score","AUC value")
print (sensitivity, specificity, accuracy,precision,f1_score,roc_auc)



