###############################
## ABDpred Server
## Version 1.0
###############################

from keras.wrappers.scikit_learn import KerasClassifier
from sklearn.model_selection import cross_val_score
from keras.layers import Dense, Dropout, Flatten
from keras.models import Sequential
from keras.layers import Dense
import pandas as pd
from keras import regularizers
from keras.layers import Dense, Dropout, Flatten
from sklearn.model_selection import StratifiedKFold
from tensorflow.keras.losses import sparse_categorical_crossentropy
import warnings  
warnings.filterwarnings('ignore')

from sklearn.model_selection import cross_val_score
from keras import regularizers
from tensorflow import keras
from keras.layers import Dense, Dropout, Flatten
from keras.wrappers.scikit_learn import KerasClassifier
import numpy as np 
import pandas as pd 
import os
from tensorflow.keras.losses import sparse_categorical_crossentropy
from sklearn.preprocessing import StandardScaler
import keras
import tensorflow as tf
import matplotlib.pyplot as plt
import seaborn as sns
from keras.utils import plot_model  
sns.set()
import matplotlib.pyplot as plt
#import dill as pickle
from keras.models import Sequential
from keras.layers import Dense
from sklearn.model_selection import train_test_split
from sklearn.metrics import confusion_matrix,roc_auc_score, classification_report
from sklearn import metrics
from sklearn.metrics import roc_curve, auc, plot_roc_curve
import pickle
from sklearn.metrics import accuracy_score
tf.keras.backend.floatx()


print("................................")
print("Loaded saved model")
new_model = tf.keras.models.load_model('model0')

new_model.summary()

blindset= pd.read_csv(r'blind_1_1_work_1.csv',sep=',')
Z= blindset.drop('Label',axis=1)
z= blindset['Label']
pred_blind_dnn= new_model.predict(Z)
pred_blind_dnn = (pred_blind_dnn > 0.55)

print(classification_report(z,pred_blind_dnn))
tn, fp, fn, tp=confusion_matrix(z,pred_blind_dnn).ravel()
#print (tn)
#print (fp)
#print (fn)
#print (tp)

sensitivity = (tp)/(tp+fn)
specificity=(tn/1.0)/(fp+tn)
accuracy=(tp+tn)/(tp+fp+fn+tn)
precision=(tp)/(tp+fp)
f1_score=(2*tp)/(2*tp+fp+fn)
fpr, tpr, thresholds = metrics.roc_curve(z, pred_blind_dnn)
roc_auc= auc(fpr, tpr)

print ("Sensitivity","Specificity","Accuracy","precision", "f1-score","AUC value")
print (sensitivity, specificity, accuracy,precision,f1_score,roc_auc)



