###############################
## ABDpred Server
## Version 1.0
###############################


from keras.wrappers.scikit_learn import KerasClassifier
from sklearn.model_selection import cross_val_score
from keras.layers import Dense, Dropout, Flatten
from keras.models import Sequential
from keras.layers import Dense
import pandas as pd
from keras import regularizers
from keras.layers import Dense, Dropout, Flatten
from sklearn.model_selection import StratifiedKFold

import warnings  
warnings.filterwarnings('ignore')

df = pd.read_csv(r"train_1_1_work_1.csv")
df.describe()
df.head()
X_train= df.drop('Label',axis=1)
y_train= df.Label

from sklearn.preprocessing import StandardScaler
sc = StandardScaler()
X = sc.fit_transform(X_train)



def build_classifier():
    classifier = Sequential()
    classifier.add(Dense(units = 10, kernel_initializer = 'uniform', activation = 'relu', input_dim = 17))
    classifier.add(Dense(units = 10, kernel_initializer = 'uniform', activation = 'relu'))
    classifier.add(Dense(units = 1, kernel_initializer = 'uniform', activation = 'sigmoid'))
    classifier.compile(optimizer = 'adam', loss = 'binary_crossentropy', metrics = ['accuracy'])
    return classifier
    
classifier = KerasClassifier(build_fn = build_classifier, batch_size = 5, epochs = 100,verbose=0)
accuracies = cross_val_score(estimator = classifier, X = X_train, y = y_train, cv = StratifiedKFold(5))
print (accuracies)
mean = accuracies.mean()
variance = accuracies.std()
print('Mean accuracy score of 5 different models using Stratified KFold cross validation: {}'.format(mean))
print('Standard Deviation of accuracy score of 5 different models using Stratified KFold cross validation: {}'.format(variance))


