###############################
## ABDpred Server
## Version 1.0
###############################



import numpy as np
import pandas as pd
from sklearn.ensemble import RandomForestClassifier
from sklearn.metrics import confusion_matrix, classification_report
from sklearn.model_selection import train_test_split
from sklearn.metrics import roc_curve
from sklearn import metrics
from sklearn.svm import LinearSVC
from sklearn import datasets, metrics, model_selection, svm
from sklearn.neural_network import MLPClassifier
import xgboost as xgb
from sklearn.ensemble import GradientBoostingClassifier
from sklearn.tree import DecisionTreeClassifier




dataset = pd.read_csv(r'data\train_1_1_work_1.csv',sep=',')
X= dataset.drop('Level',axis=1)
y= dataset['Level']
X_train, X_test, y_train, y_test = train_test_split(X,y, test_size=0.20, random_state=42)

dtree_clf=DecisionTreeClassifier()
dtree_clf.fit(X_train,y_train)
DecisionTreeClassifier()
ypred2=  dtree_clf.predict(X_test)
ypred2
print ("Dtree scores_GB_classifier Training_Testing scores: ", dtree_clf.score (X_test, y_test))
print("Dtree Training_Testing classification_report: ", classification_report(y_test, ypred2))
fpr, tpr, thresholds = metrics.roc_curve(y_test, ypred2)
print ("AUC Values: ", metrics.auc(fpr, tpr), thresholds)
print ("thresholds: ", thresholds)




