###############################
## ABDpred Server
## Version 1.0
###############################





import numpy as np
import pandas as pd
from sklearn.ensemble import RandomForestClassifier
from sklearn.metrics import confusion_matrix, classification_report
from sklearn.model_selection import train_test_split
from sklearn.metrics import roc_curve
from sklearn import metrics
from sklearn.svm import LinearSVC
from sklearn import datasets, metrics, model_selection, svm
from sklearn.svm import LinearSVC







dataset = pd.read_csv(r'data\train_1_1_work_1.csv',sep=',')
X= dataset.drop('Label',axis=1)
y= dataset['Label']
X_train, X_test, y_train, y_test = train_test_split(X,y, test_size=0.20, random_state=42)

clf = svm.SVC(C=350, gamma= 0.00001, kernel='rbf').fit(X_train, y_train)
print ("SVM classifier Training score: ", clf.score (X_test, y_test))
pred_clf=clf.predict(X_test)
print("SVM classification report: ", classification_report(y_test, pred_clf))
fpr, tpr, thresholds = metrics.roc_curve(y_test, pred_clf)
print ("AUC Values: ", metrics.auc(fpr, tpr))
print (thresholds)
