###############################
## ABDpred Server
## Version 1.0
###############################



#!/usr/bin/env python


# importing required pacakages:
import pandas as pd
import seaborn as sns
import matplotlib.pyplot as plt
from sklearn.ensemble import RandomForestClassifier
from sklearn.svm import SVC
from sklearn import svm
from sklearn.neural_network import MLPClassifier
from sklearn.metrics import confusion_matrix, classification_report
from sklearn.preprocessing import StandardScaler, LabelEncoder
from sklearn.model_selection import train_test_split
from sklearn.metrics import roc_curve
import matplotlib.pyplot as plt
import matplotlib.pyplot as plt  # doctest: +SKIP
from sklearn import datasets, metrics, model_selection, svm
from sklearn.metrics import plot_roc_curve
from sklearn.datasets import load_wine
from sklearn.datasets import load_iris
from sklearn.feature_selection import SelectKBest
from sklearn.feature_selection import chi2
from sklearn.feature_selection import VarianceThreshold
from sklearn.svm import LinearSVC
from sklearn.datasets import load_iris
from sklearn.feature_selection import SelectFromModel
from sklearn.metrics import confusion_matrix, classification_report
from sklearn.ensemble import GradientBoostingClassifier
from sklearn.tree import DecisionTreeClassifier
import xgboost as xgb
from sklearn import metrics
import numpy as np
import pandas as pd
import seaborn as sns
import matplotlib.pyplot as plt
from sklearn.ensemble import RandomForestClassifier
from sklearn.svm import SVC
from sklearn import svm
from sklearn.neural_network import MLPClassifier
from sklearn.metrics import confusion_matrix, classification_report
from sklearn.preprocessing import StandardScaler, LabelEncoder
from sklearn.model_selection import train_test_split
from sklearn.metrics import roc_curve
import matplotlib.pyplot as plt  # doctest: +SKIP
from sklearn import datasets, metrics, model_selection, svm
from sklearn.metrics import plot_roc_curve
from sklearn.datasets import load_wine
from sklearn.datasets import load_iris
from sklearn.feature_selection import SelectKBest
from sklearn.feature_selection import chi2
from sklearn.feature_selection import VarianceThreshold
from sklearn.svm import LinearSVC
from sklearn.feature_selection import SelectFromModel
from sklearn.ensemble import GradientBoostingClassifier
from sklearn.tree import DecisionTreeClassifier
import xgboost as xgb
from sklearn.model_selection import KFold
from sklearn.datasets import load_digits
from sklearn.linear_model import LogisticRegression

dataset = pd.read_csv(r'data\train_1_1_work_1.csv',sep=',')
#blindset= pd.read_csv(r'blind_1_1_work_1.csv',sep=',')




#digits =load_digits()

#digits.target()
X= dataset.drop('Label',axis=1)
y= dataset['Label']


#lsvc = LinearSVC(C=0.001, penalty="l1", dual=False).fit(X, y)
#model = SelectFromModel(lsvc, prefit=True)
#X_new = model.transform(X)


X_train, X_test, y_train, y_test = train_test_split(X,y, test_size=0.20, random_state=42)


sc = StandardScaler ()
X_train = sc.fit_transform(X_train)
X_test = sc.fit_transform(X_test)

#pprint ('Performance of Random forest')
#rfc = RandomForestClassifier(n_estimators=201, random_state=92)
#rfc.fit(X_train,y_train)
#pred_rfc=rfc.predict(X_test)
#pred_rfc[:20]
#pred_rfc


rfc = RandomForestClassifier(n_estimators=201, random_state=92, bootstrap=True, max_samples=200, ccp_alpha=0.0)
print (rfc)
rfc.fit(X_train,y_train)
print ("Random Forest classifier Scores: ", rfc.score (X_test, y_test))
pred_rfc=rfc.predict(X_test)
print("Random Forest classifier Classification report: " , classification_report(y_test, pred_rfc))
#print(confusion_matrix(y_test, pred_rfc))

clf = svm.SVC(C=2500, gamma= 0.00001, kernel='rbf').fit(X_train, y_train)
#clf = svm.SVC(kernel='rbf', C=10).fit(X_train, y_train)

print ("SVM classifier scorres: ", clf.score (X_test, y_test))
pred_clf=clf.predict(X_test)
print("SVM classification report: ", classification_report(y_test, pred_clf))


#print ('Performance of Neural Network')
mlpc = MLPClassifier(hidden_layer_sizes=[99,9,9],max_iter=100,random_state=62, batch_size=320)
mlpc.fit(X_train, y_train)
pred_mlpc=mlpc.predict(X_test)
print ("mlpc score:  ", mlpc.score (X_test, y_test))
print("mlpc classification_report: ",classification_report(y_test, pred_mlpc))
#print(confusion_matrix(y_test, pred_mlpc))




xgb_classifier=xgb.XGBClassifier(learning_rate =0.1, n_estimators=1000, max_depth=5,min_child_weight=1, gamma=0, subsample=0.8, colsample_bytree=0.80, objective= 'binary:logistic', nthread=4, scale_pos_weight=1, seed=27)
xgb_classifier.fit(X_train, y_train)
print ("XGboost classifier Scores: ", xgb_classifier.score (X_test, y_test))
predictions=  xgb_classifier.predict(X_test)
#predictions
print("XGboost classifier classification_report:  ", classification_report(y_test, predictions))



GB_classifier=GradientBoostingClassifier()
GB_classifier.fit(X_train,y_train)
GradientBoostingClassifier()
print ("GradientBoostingClassifier Scores", GB_classifier.score (X_test, y_test))
y_predictions =GB_classifier.predict(X_test)
y_predictions
print("GradientBoostingClassifier classification_report: ", classification_report(y_test, y_predictions))


dtree_clf=DecisionTreeClassifier()
dtree_clf.fit(X_train,y_train)
DecisionTreeClassifier()
ypred2=  dtree_clf.predict(X_test)
ypred2
print ("Dtree scores_GB_classifier scores: ", dtree_clf.score (X_test, y_test))
print("Dtree classification_report: ", classification_report(y_test, ypred2))


lr = LogisticRegression(tol=0.01, penalty='l2', solver='saga', random_state=0).fit(X, y)
lr_pred=  lr.predict(X_test)
print ("Logistic Regression scores: ", lr.score (X_test, y_test))
print("Dtree classification_report: ", classification_report(y_test, lr_pred))


# #############################################################################

#K Fold cross validation
kf=KFold (n_splits=5)
#print (kf)

for train_index, test_index in kf.split ([1,2,3,4,5]):
    print (train_index, test_index)
    
def get_score (model, X_train, X_test, y_train, y_test):
    model.fit(X_train, y_train)
    return model.score (X_test, y_test)
 

#print (get_score ( RandomForestClassifier(n_estimators=201, random_state=92),X_train, X_test, y_train, y_test))

from sklearn.model_selection import StratifiedKFold
folds = StratifiedKFold (n_splits=5)
scores_rf =[]
scores_clf=[]
scores_mlpc=[]
scores_xgb=[]
scores_GB_classifier=[]
scores_dtree_clf=[]
scores_lr_pred=[]



#for train_index, test_index in kf.split (X):
    #X_train, X_test, y_train, y_test = X[train_index], X[test_index], y[train_index], y[test_index]
#print (get_score ( RandomForestClassifier(),X_train, X_test, y_train, y_test))

from sklearn.model_selection import cross_val_score
scores_rf.append(cross_val_score (RandomForestClassifier(n_estimators=201, random_state=92, bootstrap=True, max_samples=200, ccp_alpha=0.0),X, y))
print ("Random Forest Cross val score: ",scores_rf)

scores_clf.append(cross_val_score (SVC(C=2500, gamma= 0.00001, kernel='rbf'),X, y))
print ("SVC cross val score: ",scores_clf)

#scores_mlpc.append(cross_val_score (MLPClassifier(hidden_layer_sizes=(11, 9, 9), max_iter=255),X, y))

scores_mlpc.append(cross_val_score( MLPClassifier(hidden_layer_sizes=[99,9,9],max_iter=100,random_state=62, batch_size=320),X, y))
print ("MLPClassifier cross val score: ",scores_mlpc)

scores_xgb.append(cross_val_score (xgb_classifier,X, y))
print ("XGboost cross val score: ",scores_xgb)

scores_GB_classifier.append(cross_val_score (GradientBoostingClassifier(),X, y))
print ("GB_classifier cross val score: ",scores_GB_classifier)

scores_dtree_clf.append(cross_val_score (DecisionTreeClassifier(),X, y))
print ("DecisionTreeClassifier cross val score: ",scores_dtree_clf)

scores_lr_pred.append(cross_val_score (lr,X, y))
print ("LogisticRegression cross val score: ",scores_lr_pred)


#rfc_disp = plot_roc_curve(rfc, X_test, y_test)
#mlpc_disp = plot_roc_curve(mlpc, X_test, y_test)

ax = plt.gca()
rfc_disp = plot_roc_curve(rfc, X_test, y_test, ax=ax, alpha=0.8)
svc_disp = plot_roc_curve(clf, X_test, y_test).plot(ax=ax, alpha=0.87)
svc_mlpc = plot_roc_curve(mlpc, X_test, y_test).plot(ax=ax, alpha=0.8)
xgb_disp = plot_roc_curve(xgb_classifier, X_test, y_test).plot(ax=ax, alpha=0.5)
gb_disp = plot_roc_curve(GB_classifier, X_test, y_test, ax=ax, alpha=0.5)
dtree_disp = plot_roc_curve(dtree_clf, X_test, y_test).plot(ax=ax, alpha=0.5)
lr_disp = plot_roc_curve(lr, X_test, y_test).plot(ax=ax, alpha=0.5)
#xgb_disp = plot_roc_curve(xgb_classifier, X_test, y_test).plot(ax=ax, alpha=0.5)
ax = plt.gca()
plt.show()


